const categoriesModel = require('./categoriesModel');
async function getCategoriesToTryCheck() {
    const limit = 15;
    const categories = await categoriesModel.getCategoriesToTryCheck(limit);
    for (const category of categories) {
        categoriesModel.updateCategoryTryCheckedAt(category.id);
    }

    return categories;

}

async function getCategoryByUrl(url) {
    return await categoriesModel.getCategoryByUrl(url);
}

async function getCategoryByNodeIdAndDepartmentId(nodeId, departmentId) {
    return await categoriesModel.getCategoryByNodeIdAndDepartmentId(nodeId, departmentId);
}
async function updateCategoryCheckedAtByUrl(url) {
    categoriesModel.updateCategoryCheckedAtByUrl(url);
}
async function updateCategoryByUrl(url, category) {
    return await categoriesModel.updateCategoryByUrl(url, category);
}

async function updateCategoryByNodeIdAndDepartmentId(nodeId, departmentId, category) {
    return await categoriesModel.updateCategoryByNodeIdAndDepartmentId(nodeId, departmentId, category);
}

async function upsertCategory(category) {
    // Validate the category data
    if (!category.url || !category.nodeId || !category.departmentId || !category.name || !category.productsCount || !category.pages) {
        throw new Error('Invalid category data');
    }

    const existingCategory = await categoriesModel.getCategoryByUrl(category.url);
    if (existingCategory.length > 0) {
        return await categoriesModel.updateCategoryByUrl(category.url, category);
    } else {
        console.log('createCategory:', category)
        return await categoriesModel.createCategory(category);
    }
}

module.exports = {
    getCategoryByUrl,
    getCategoriesToTryCheck,
    getCategoryByNodeIdAndDepartmentId,
    updateCategoryByUrl,
    updateCategoryByNodeIdAndDepartmentId,
    upsertCategory,
    updateCategoryCheckedAtByUrl,
};